#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const commander_1 = require("commander");
const server_1 = require("./server");
const utils = require("./utils");
const program = new commander_1.Command('typescript-language-server')
    .version(require('../package.json').version)
    .option('--stdio', 'use stdio')
    .option('--node-ipc', 'use node-ipc')
    .option('--socket <port>', 'use socket. example: --socket=5000')
    .option('--tsserver-path <path>', `absolute path to tsserver. example: --tsserver-path=${utils.isWindows() ? 'c:\\tsc\\tsserver.cmd' : '/bin/tsserver'}`, utils.isWindows() ? 'tsserver.cmd' : 'tsserver')
    .parse(process.argv);
if (!(program.stdio || program.socket || program['node-ipc'])) {
    console.error('Connection type required (stdio, node-ipc, socket). Refer to --help for more details.');
    process.exit(1);
}
new server_1.Server({
    tsserverPath: program.tsserverPath
}).listen();
